#include "stdafx.h"
#include <mmsystem.h>
#include <dsound.h>
#include "DSoundEnv.h"
#include "PCMSound.h"
#include "StreamSound.h"
#include <crtdbg.h>
LRESULT CALLBACK WndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);

CDSoundEnv	*g_pDSoundEnv = NULL;
CPCMSound	*g_pPCMSound = NULL;
CStreamSound	*g_pStreamSound = NULL;
#define	STREAM_VOL	-100
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );

    WNDCLASSEX wcex;
    wcex.cbSize = sizeof(WNDCLASSEX); 
    wcex.style            = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)WndProc;
    wcex.cbClsExtra        = 0;
    wcex.cbWndExtra        = 0;
    wcex.hInstance        = hInstance;
    wcex.hIcon            = LoadIcon(NULL, MAKEINTRESOURCE(IDI_APPLICATION));
    wcex.hCursor        = LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
    wcex.hbrBackground    = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName    = NULL;
    wcex.lpszClassName    = "tuto00 an DirectSound Application";
    wcex.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);
    RegisterClassEx(&wcex);

    HWND hWnd;
    hWnd = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW,wcex.lpszClassName,"tuto00",
                WS_VISIBLE|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX,
                CW_USEDEFAULT,0,640,480,NULL,NULL,hInstance,NULL);
    if( !hWnd )
        return FALSE;

    RECT    bounds,client;
    GetWindowRect(hWnd,&bounds);
    GetClientRect(hWnd,&client);
    MoveWindow(hWnd,bounds.left,bounds.top,
        640 * 2 - client.right,
        480 * 2 - client.bottom,
        false );

    ShowWindow( hWnd, nCmdShow );
    UpdateWindow( hWnd );
	g_pDSoundEnv = new CDSoundEnv(2,44100,16);
	if (g_pDSoundEnv){
		if (SUCCEEDED(g_pDSoundEnv->Initialize(hWnd,DSSCL_PRIORITY))){
			g_pPCMSound = new CPCMSound(g_pDSoundEnv,"sound\\test.wav");
			if (g_pPCMSound){
				g_pPCMSound->Reload();
			}
			g_pStreamSound = new CStreamSound(g_pDSoundEnv,"sound\\teststream.wav");
			if (g_pStreamSound){
				g_pStreamSound->Prepare();
				g_pStreamSound->SetLoop(true);
			}
		}
	}
	BOOL	bFlag1 = false;
	BOOL	bFlag2 = false;
	BOOL	bFlag3 = false;
	BOOL	bFlag4 = false;
	BOOL	bFlag5 = false;
	BOOL	bFlag6 = false;
	BOOL	bFlag2Stop = false;
    MSG        msg;
    while(true){
        if(PeekMessage(&msg, 0, 0, 0, PM_REMOVE)){
            if(msg.message == WM_QUIT)
                break;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }else{
			if (::GetAsyncKeyState('1')){
				if (!bFlag1 && g_pPCMSound)
					g_pPCMSound->Play(0,0,STREAM_VOL);
				bFlag1 = true;
			}else{
				bFlag1 = false;
			}
			if (::GetAsyncKeyState(VK_SPACE)){
				if (!bFlag2 && g_pStreamSound)
					g_pStreamSound->Play(0,0,STREAM_VOL);
				bFlag2 = true;
			}else{
				bFlag2 = false;
			}
			if (::GetAsyncKeyState('2')){
				if (!bFlag3 && g_pStreamSound)
					g_pStreamSound->Play(0,0,STREAM_VOL,-1,0,180);
				bFlag3 = true;
			}else{
				bFlag3 = false;
	
			}
			if (::GetAsyncKeyState('3')){
				if (!bFlag4 && g_pStreamSound)
					g_pStreamSound->FadeOut(180);
				bFlag4 = true;
			}else{
				bFlag4 = false;
	
			}
			if (::GetAsyncKeyState('4')){
				if (!bFlag5 && g_pStreamSound)
					g_pStreamSound->SetVol(-9600,6.0f);
				bFlag5 = true;
			}else{
				bFlag5 = false;
	
			}
			if (::GetAsyncKeyState('5')){
				if (!bFlag6 && g_pStreamSound)
					g_pStreamSound->SetVol(STREAM_VOL,6.0f);
				bFlag6 = true;
			}else{
				bFlag6 = false;
	
			}
			if (::GetAsyncKeyState(VK_RETURN)){
				if (!bFlag2Stop && g_pStreamSound)
					g_pStreamSound->Pause();
				bFlag2Stop = true;
			}else{
				bFlag2Stop = false;
			}
			g_pDSoundEnv->PollStatus();
        }
	}
	if (g_pStreamSound)
		delete	g_pStreamSound;
	if (g_pPCMSound){
		delete	g_pPCMSound;
	}
	if (g_pDSoundEnv)
		delete	g_pDSoundEnv;
    return (int)msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	HDC	hDC = NULL;
	PAINTSTRUCT	psInfo;
	COLORREF	colOld;
	const TCHAR	mes1[]="DSQuickLib Tutorial.";
	const TCHAR mes2[]="key\'1\' -- Play PCM";
	const TCHAR mes3[]="key\'2\' -- Play PCM stream with fade-in";
	const TCHAR mes4[]="key\'3\' -- fade-out the PCM stream.";
	const TCHAR mes5[]="key\'4\' -- mute the PCM stream.";
	const TCHAR mes6[]="key\'5\' -- unmute the PCM stream.";
	const TCHAR mes7[]="SPACE  -- Play PCM stream.";
	const TCHAR mes8[]="ENTER  -- Pause PCM stream.";

	switch (message){
		case WM_PAINT:
			hDC = BeginPaint(hWnd,&psInfo);
			if (hDC != NULL){
				colOld = SetTextColor(hDC,RGB(0,0,0));
				ExtTextOut(hDC,10,10,0,NULL,mes1,(int)_tcslen(mes1),NULL);
				ExtTextOut(hDC,40,40,0,NULL,mes2,(int)_tcslen(mes2),NULL);
				ExtTextOut(hDC,40,60,0,NULL,mes3,(int)_tcslen(mes3),NULL);
				ExtTextOut(hDC,40,80,0,NULL,mes4,(int)_tcslen(mes4),NULL);
				ExtTextOut(hDC,40,100,0,NULL,mes5,(int)_tcslen(mes5),NULL);
				ExtTextOut(hDC,40,120,0,NULL,mes6,(int)_tcslen(mes6),NULL);
				ExtTextOut(hDC,40,140,0,NULL,mes7,(int)_tcslen(mes7),NULL);
				ExtTextOut(hDC,40,160,0,NULL,mes8,(int)_tcslen(mes8),NULL);
				SetTextColor(hDC,colOld);
				EndPaint(hWnd,&psInfo);
			}
			::ValidateRect(hWnd,NULL);
			break;
        case WM_DESTROY:
            PostQuitMessage(0);
            break;
        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return    0;
}

